#ifndef PACKET_HPP
#define PACKET_HPP

#include "x_huff.hpp"
#include "unique.hpp"

#define FRAME_CHAR		0xff
#define PKT_CONTROL		0x80
#define PKT_COMPRESSED		0x40
#define PKT_ADDR		0x3f
#define PACKET_CONTROL(c)	((c) & PKT_CONTROL)
#define PACKET_COMPRESSED(c)	((c) & PKT_COMPRESSED)
#define PACKET_ADDR(c)		((c) & PKT_ADDR)
#define	DEST_HDR(c)		(((c) & ~PKT_ADDR) | nodeAddr)
#define CTRL_CONNECT            0
#define CTRL_DISCONNECT         1
#define CTRL_SETUP_REQUEST      2
#define CTRL_SETUP_NOTIFY       3
#define CTRL_RESET_REQUEST      4
#define CTRL_RESET_NOTIFY       5
#define CTRL_SYNC_REQUEST       6
#define CTRL_SYNC_NOTIFY        7

void			findNodes();
#ifdef SETUP
void			doSetup();
#endif
void		        sync();
int			getPacket();
void			broadcastPacket();
void			sendPacket();
#ifdef DEBUG
void			packetDebug();
#endif
#ifdef HUFSTATS
void			hufStats();
#endif

extern int			localStack;
extern byte			stack[2048];
extern word			savedFlags, savedSS, savedSP, savedBP, savedAX;
extern int			clientApproved;
extern int			nodeExists[MAX_NETNODES];
extern int			gameInProgress, initialNodes, nodeAddr, remoteAddr, maxAddr;
extern int			packetLen;
extern byte			*packet;
extern byte			buf[(MAX_PACKET * 9 / 8 + 1) * 2 + 4];
extern int			bufLen;
extern word                     nPacketsWaiting;
#ifdef SETUP
extern int			setupSource;
#endif
#ifdef DEBUG
extern word                     maxPacketsWaiting;
extern int			nMisc;
extern word			misc[64];
#endif

#define	setLocalStack()		{ setLocalStack1(); setLocalStack2(); }
extern void			cli();
extern void			sti();
extern void			pushf();
extern void			popf();
extern void			iret();
extern word			getAX();
extern word			getBX();
extern word			getCX();
extern word			getDX();
extern word			getES();
extern word			getSI();
extern word			getDI();
extern void			setAL(byte AL);
extern void			setAX(word AX);
extern void			setBX(word BX);
extern void			setCX(word CX);
extern void			setDX(word DX);
extern void			setES(word ES);
extern void			setSI(word SI);
extern void			setDI(word DI);
extern void			setLocalStack1();
extern void			setLocalStack2();
extern void			unsetLocalStack();

#pragma aux cli = "cli";

#pragma aux sti = "sti";

#pragma aux pushf = "pushf";

#pragma aux popf = "popf";

#pragma aux iret = "iret";

#pragma aux getAX =				\
	value	[ax]				;

#pragma aux getBX =				\
	"mov	ax, bx"				\
	value	[ax]				;

#pragma aux getCX =				\
	"mov	ax, cx"				\
	value	[ax]				;

#pragma aux getDX =				\
	"mov	ax, dx"				\
	value	[ax]				;

#pragma aux getES =				\
	"mov	ax, es"				\
	value	[ax]				;

#pragma aux getSI =				\
	"mov	ax, si"				\
	value	[ax]				;

#pragma aux getDI =				\
	"mov	ax, di"				\
	value	[ax]				;

#pragma aux setAL =				\
	parm	[al]				;

#pragma aux setAX =				\
	parm	[ax]				;

#pragma aux setBX =				\
	parm	[bx]				;

#pragma aux setCX =				\
	parm	[cx]				;

#pragma aux setDX =				\
	parm	[dx]				;

#pragma aux setES =				\
	parm	[es]				;

#pragma aux setSI =				\
	parm	[si]				;

#pragma aux setDI =				\
	parm	[di]				;

#pragma aux setLocalStack1 =                    \
	"pushf"					\
        "cli"                                   \
	"pop	savedFlags"			\
        "mov    savedSS, ss"                    \
        "mov    savedSP, sp"                    \
	"mov	savedBP, bp"			\
	"mov	savedAX, ax"			;

#pragma aux setLocalStack2 =			\
        "mov    ax, SEG stack"                  \
        "mov    ss, ax"                         \
        "mov    sp, OFFSET stack + 2016"        \
	"mov	bp, OFFSET stack + 2048"	\
	"mov	ax, savedAX"			\
        "mov    localStack, 1"                  \
	"push	savedFlags"			\
	"popf"					;

#pragma aux unsetLocalStack =			\
	"pushf"					\
        "cli"                                   \
	"pop	savedFlags"			\
        "mov    ss, savedSS"                    \
        "mov    sp, savedSP"                    \
	"mov	bp, savedBP"			\
        "mov    localStack, 0"                  \
	"push	savedFlags"			\
	"popf"					;

#endif
