#ifndef X_CRC32_H
#define X_CRC32_H

#include "x_types.h"

class CRC32 {
protected:
  dword         crc;
  dword         *table;
  void          buildTable();
public:
  void          init();
  inline dword  CRC() { return crc; };
  inline void   addByte(byte b);
  void          addString(byte *p, dword n);
  CRC32();
  ~CRC32();
};

inline void CRC32::addByte(byte b) {
  dword t1, t2;
  t1 = (crc >> 8) & 0xffffff;
  t2 = table[((int) crc ^ b) & 0xff];
  crc = t1 ^ t2;
}

#endif
